{*******************************************************************************
  Copyright (C) Michael W. Vogel m-w-vogel@gmx.de

  The contents of this file are subject to the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 3.0 of the License,
  or (at your option) any later version.
  You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
  specific language governing rights and limitations under the License.

  Created 02.09.2015
*******************************************************************************}

unit About;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fileinfo, FileUtil, Forms, Controls,
  Graphics, Dialogs, StdCtrls;

type

  { TfrmAbout }

  TfrmAbout = class(TForm)
    btnOK: TButton;
    Memo: TMemo;
    procedure btnOKClick({%H-}Sender: TObject);
    procedure FormShow({%H-}Sender: TObject);
    procedure MemoEnter({%H-}Sender: TObject);
  end;

var
  frmAbout: TfrmAbout;

implementation

{$R *.lfm}

resourcestring
  CAbout              = 'About';
  COk                 = 'OK';
  SCopyRight1         = 'Copyright (C) Michael W. Vogel m-w-vogel@gmx.de';
  SCopyRight2         = 'This program is fully written in Lazarus/FPC and released under the GNU Lesser '+
                        'General Public License as published by the Free Software Foundation; either '+
                        'version 3.0 of the License, or (at your option) any later version.You may obtain '+
                        'a copy of the LGPL at http://www.gnu.org/copyleft/.';
  SCopyRight3         = 'Software distributed under the License is distributed on an "AS IS" basis, '+
                        'WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the '+
                        'specific language governing rights and limitations under the License.';

{ TfrmAbout }

procedure TfrmAbout.FormShow(Sender: TObject);

  {$IF FPC_FULLVERSION >= 20701}
  function ProjectInfos: String;
  var
    FileVerInfo: TFileVersionInfo;
  begin
    Result := '';
    FileVerInfo := TFileVersionInfo.Create(nil);
    try
      FileVerInfo.FileName := ParamStr(0);
      FileVerInfo.ReadFileInfo;
      Result := FileVerInfo.VersionStrings.Values['ProductName'];
      Result := Result + ' ' + FileVerInfo.VersionStrings.Values['ProductVersion'];
    finally
      FileVerInfo.Free;
    end;
  end;
  {$ENDIF}

begin
  Caption := CAbout;
  btnOK.Caption := COk;
  Memo.Clear;
  {$IF FPC_FULLVERSION >= 20701}
  Memo.Lines.Add(ProjectInfos + ' ' + SCopyRight1);
  Memo.Lines.Add(EmptyStr);
  {$ENDIF}
  Memo.Lines.Add(SCopyRight2);
  Memo.Lines.Add(EmptyStr);
  Memo.Lines.Add(SCopyRight3);
end;

procedure TfrmAbout.btnOKClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAbout.MemoEnter(Sender: TObject);
begin
  btnOK.SetFocus;
end;

end.

