{*******************************************************************************
  Copyright (C) Michael W. Vogel m-w-vogel@gmx.de

  The contents of this file are subject to the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 3.0 of the License,
  or (at your option) any later version.
  You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
  specific language governing rights and limitations under the License.

  Created 02.09.2015
*******************************************************************************}

{ TODO Debugger Einstellungen: --eval-command="set auto-solib-add off" setzen

Aboutfenster bauen
ICONs überarbeiten

}

unit DefacerMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IniFiles, fileinfo, FileUtil, Forms,
  Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  PairSplitter, ActnList, Menus, Buttons, LCLType, Defaces,
  VirtualTrees, VirtualFileTrees, ArchiveParser,
  DefacerTools, DefacerStrings, About, Progresses, DCPrijndael;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    actInDefaceCodeFileAdd: TAction;
    actInDefaceCodeFileDel: TAction;
    actCodeFileRandom: TAction;
    actInDefaceFileAdd: TAction;
    actInDefaceFileDel: TAction;
    actInDefaceDirAdd: TAction;
    actAbout: TAction;
    actSaveFile: TAction;
    actOutDeface: TAction;
    actLoadFile: TAction;
    ActionList1: TActionList;
    btnInDeface: TBitBtn;
    btnOuDeface: TBitBtn;
    btnOutDefaceSelectFile: TSpeedButton;
    DCP_rijndael1: TDCP_rijndael;
    edtOutDefaceFile: TEdit;
    edtPassword: TEdit;
    gbxCodeFile: TGroupBox;
    gbxOutDefaceFile: TGroupBox;
    gbxInDeface: TGroupBox;
    gbxOutDeface: TGroupBox;
    gbxPassWord: TGroupBox;
    ImageList1: TImageList;
    ImageList2: TImageList;
    lbxCodeFileList: TListBox;
    MainMenu1: TMainMenu;
    mnuAbout: TMenuItem;
    mnuHelp: TMenuItem;
    mnuLoadFile: TMenuItem;
    mnuSlash1: TMenuItem;
    mnuSaveFile: TMenuItem;
    mnuDirAdd: TMenuItem;
    mnuFileAdd: TMenuItem;
    mnuFileDel: TMenuItem;
    mnuCodeFileRandom: TMenuItem;
    mnuCodeFileDel: TMenuItem;
    mnuCodeFileAdd: TMenuItem;
    mnuCodeFileList: TMenuItem;
    mnuFile: TMenuItem;
    OpenDialog1: TOpenDialog;
    pacMain: TPageControl;
    Progress1: TProgress;
    pspInDeface: TPairSplitter;
    pspOutDeface: TPairSplitter;
    pspInDefaceLeft: TPairSplitterSide;
    pspInDefaceRight: TPairSplitterSide;
    pspOutDefaceLeft: TPairSplitterSide;
    pspOutDefaceRight: TPairSplitterSide;
    SaveDialog1: TSaveDialog;
    btnPasswordVisible: TSpeedButton;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    pacInDeface: TTabSheet;
    pacOutDeface: TTabSheet;
    tobCode: TToolBar;
    tobInDeface: TToolBar;
    tobAddCodeFile: TToolButton;
    tobDelCodeFile: TToolButton;
    tobAddFile: TToolButton;
    tobAddDir: TToolButton;
    tobDelFile: TToolButton;
    vftInDeface: TVirtualFileTree;
    vftOutDeface: TVirtualFileTree;
    procedure actAboutExecute({%H-}Sender: TObject);
    procedure actOutDefaceExecute({%H-}Sender: TObject);
    procedure actLoadFileExecute({%H-}Sender: TObject);
    procedure actInDefaceCodeFileAddExecute({%H-}Sender: TObject);
    procedure actInDefaceCodeFileDelExecute({%H-}Sender: TObject);
    procedure actCodeFileRandomExecute({%H-}Sender: TObject);
    procedure actInDefaceDirAddExecute({%H-}Sender: TObject);
    procedure actInDefaceFileAddExecute({%H-}Sender: TObject);
    procedure actInDefaceFileDelExecute({%H-}Sender: TObject);
    procedure actSaveFileExecute({%H-}Sender: TObject);
    procedure FormCreate({%H-}Sender: TObject);
    procedure FormDestroy({%H-}Sender: TObject);
    procedure FormDropFiles({%H-}Sender: TObject;
      const FileNames: array of String);
    procedure lbxCodeFileListSelectionChange({%H-}Sender: TObject;
      {%H-}User: boolean);
    procedure btnPasswordVisibleClick({%H-}Sender: TObject);
    procedure pacMainChange({%H-}Sender: TObject);
    procedure vftInDefaceChange({%H-}Sender: TBaseVirtualTree;
      {%H-}Node: PVirtualNode);
  private
    InDefacer: TInDefacer;
    OutDefacer: TOutDefacer;
    FTempPath: String;
    FIniFile: String;
    procedure lbxCodeFileListRefresh;
    procedure vftFileRefresh;
    procedure OutDefaceRefreshPage;
    procedure ArchiveFileNamesRead({%H-}Sender: TObject);
    procedure StartInDeface;
    procedure StartOutDeface;
    procedure InitInDefacePage;
    procedure InitOutDefacePage;
    procedure LoadProperties;
    procedure SaveProperties;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.actCodeFileRandomExecute(Sender: TObject);
begin
  SaveDialog1.DefaultExt := 'cdf';
  SaveDialog1.Filter     := 'Codefile Defacer|*.cdf';
  if SaveDialog1.Execute then begin
    SaveRandomCodeDataFile(SaveDialog1.FileName);
    InDefacer.CodeFileAdd(SaveDialog1.FileName);
    lbxCodeFileListRefresh;
  end;
end;

procedure TfrmMain.actInDefaceDirAddExecute(Sender: TObject);
var
  i: Integer;
begin
  SelectDirectoryDialog1.DefaultExt := '';
  SelectDirectoryDialog1.Filter     := 'All files|*.*';
  if SelectDirectoryDialog1.Execute then begin
    for i := 0 to SelectDirectoryDialog1.Files.Count - 1 do
      vftInDeface.AddDir(SelectDirectoryDialog1.Files[i]);
    vftFileRefresh;
  end;
end;

procedure TfrmMain.actInDefaceFileAddExecute(Sender: TObject);
var
  i: Integer;
begin
  OpenDialog1.DefaultExt := '';
  OpenDialog1.Filter     := 'All files|*.*';
  OpenDialog1.Options    := OpenDialog1.Options + [ofAllowMultiSelect];
  if OpenDialog1.Execute then begin
    for i := 0 to OpenDialog1.Files.Count - 1 do
      vftInDeface.AddFile(OpenDialog1.Files[i]);
    vftFileRefresh;
  end;
end;

procedure TfrmMain.actInDefaceFileDelExecute(Sender: TObject);
begin
  vftInDeface.DeleteSelectedNodes;
  vftFileRefresh;
end;

procedure TfrmMain.actSaveFileExecute(Sender: TObject);
begin
  pacMain.ActivePage := pacInDeface;

  SaveDialog1.DefaultExt := 'dff';
  SaveDialog1.Filter     := 'Defaced Files|*.dff|All files|*.*';
  if not SaveDialog1.Execute then Exit;

  if FileExists(SaveDialog1.FileName) and
      (QuestionDLG(SFileAlreadyExists,
                   Format(SOverWriteFile, [SaveDialog1.FileName]),
                   mtConfirmation,
                   [mrYes, SQuestYes, mrNo, SQuestNo, mrCancel, SQuestCancel],
                   0) <> mrYes)
    then Exit;

  StartIndeface;
end;

procedure TfrmMain.actInDefaceCodeFileAddExecute(Sender: TObject);
var
  i: Integer;
begin
  OpenDialog1.DefaultExt := 'cdf';
  OpenDialog1.Filter     := 'Codefile Defacer|*.cdf|All files|*.*';
  OpenDialog1.Options    := OpenDialog1.Options + [ofAllowMultiSelect];
  if OpenDialog1.Execute then begin
    for i := 0 to OpenDialog1.Files.Count - 1 do
      lbxCodeFileList.Items.Add(OpenDialog1.Files[i]);
    lbxCodeFileListRefresh;
  end;
end;

procedure TfrmMain.actOutDefaceExecute(Sender: TObject);
begin
  if not SelectDirectoryDialog1.Execute then Exit;

  if DirectoryHasEntries(SelectDirectoryDialog1.FileName) and
      (QuestionDLG(SDirectoryNotEmpty,
                   SOverwriteFiles,
                   mtConfirmation,
                   [mrYes, SQuestYes, mrNo, SQuestNo, mrCancel, SQuestCancel],
                   0) <> mrYes)
    then Exit;

  StartOutDeface;
end;

procedure TfrmMain.actAboutExecute(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.actLoadFileExecute(
  Sender: TObject);
begin
  OpenDialog1.DefaultExt := 'dff';
  OpenDialog1.Filter     := 'Defaced Files|*.dff|All files|*.*';
  OpenDialog1.Options    := OpenDialog1.Options - [ofAllowMultiSelect];
  if OpenDialog1.Execute then begin
    edtOutDefaceFile.Text := OpenDialog1.FileName;
    OutDefaceRefreshPage;
  end;
end;

procedure TfrmMain.actInDefaceCodeFileDelExecute(Sender: TObject);
var
  i: Integer;
begin
  if (lbxCodeFileList.Count > 0) and (lbxCodeFileList.SelCount > 0) then begin
    for i := lbxCodeFileList.Count - 1 downto 0 do
      if lbxCodeFileList.Selected[i] then begin
        InDefacer.CodeFileDel(i);
        OutDefacer.CodeFileDel(i);
      end;
    lbxCodeFileListRefresh;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);

  procedure SetEnvironmentOptions;
  begin
    FTempPath := GetEnvironmentVariable('temp') + DirectorySeparator;
    if Length(FTempPath) = 0 then
      FTempPath := ExtractFilePath(ParamStr(0));
    FIniFile := FTempPath + 'Deface.ini';
  end;
  procedure GetExternFile;
  var
    i: Integer;
  begin
    pacMain.ActivePage := pacInDeface;
    for i := 1 to ParamCount do
      if FileExists(ParamStr(i)) and (ExtractFileExt(ParamStr(i)) = '.mef') then begin
        pacMain.ActivePage    := pacOutDeface;
        edtOutDefaceFile.Text := ParamStr(i);
      end;
  end;
  {$IF FPC_FULLVERSION >= 20701}
  procedure InitMainCaption;
  var
    FileVerInfo: TFileVersionInfo;
    ProductName: String;
    ProductVersion: String;
  begin
    FileVerInfo := TFileVersionInfo.Create(nil);
    try
      FileVerInfo.FileName := ParamStr(0);
      FileVerInfo.ReadFileInfo;
      ProductName    := FileVerInfo.VersionStrings.Values['ProductName'];
      ProductVersion := FileVerInfo.VersionStrings.Values['ProductVersion'];
      Caption := ProductName + ' ' + ProductVersion;
    finally
      FileVerInfo.Free;
    end;
  end;
  {$ENDIF}
  procedure InitCaptions;
  begin
    {$IF FPC_FULLVERSION >= 20701}
    InitMainCaption;
    {$ELSE}
    Caption := 'Defacer';
    {$ENDIF}
    pacInDeface.Caption            := CpacInDeface;
    pacOutDeface.Caption           := CpacOutDeface;
    gbxCodeFile.Caption            := CgbxCodeFile;
    gbxPassWord.Caption            := CgbxPassWord;
    gbxInDeface.Caption            := CgbxInDeface;
    gbxOutDeface.Caption           := CgbxOutDeface;
    gbxOutDefaceFile.Caption       := CgbxOutDefaceFile;

    actCodeFileRandom.Caption      := CactCodeFileRandom;
    actInDefaceCodeFileAdd.Caption := CactInDefceCFileAdd;
    actInDefaceCodeFileDel.Caption := CactInDefceCFileDel;
    actInDefaceFileAdd.Caption     := CactInDefaceFileAdd;
    actInDefaceFileDel.Caption     := CactInDefaceFileDel;
    actInDefaceDirAdd.Caption      := CactInDefaceDirAdd;
    actOutDeface.Caption           := CactOutDeface;
    actLoadFile.Caption            := CactLoadFile;
    actSaveFile.Caption            := CactSaveFile;
    actAbout.Caption               := CactAbout;

    mnuFile.Caption                := CmnuFile;
    mnuCodeFileList.Caption        := CmnuCodeFileList;
    mnuHelp.Caption                := CmnuHelp;
  end;

begin
  SetEnvironmentOptions;
  GetExternFile;
  InitCaptions;
  Randomize;
  InDefacer := TInDefacer.Create;
  OutDefacer := TOutDefacer.Create;
  OutDefacer.OnArchiveFileNamesRead := @ArchiveFileNamesRead;
  LoadProperties;
  if pacMain.ActivePage = pacInDeface then
    InitInDefacePage
  else
    InitOutDefacePage;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  SaveProperties;
  FreeAndNil(OutDefacer);
  FreeAndNil(InDefacer);
end;

procedure TfrmMain.FormDropFiles(Sender: TObject;
  const FileNames: array of String);
var
  i: Integer;
  aControl: TControl;
begin
  aControl := FindControlAtPosition(Mouse.CursorPos, true);
  if Assigned(aControl) and (aControl is TListBox) and
    (TListBox(aControl) = lbxCodeFileList)
  then
    begin
      for i := 0 to High(FileNames) do
        if FileExists(FileNames[i]) then
          InDefacer.CodeFileAdd(FileNames[i]);
      lbxCodeFileListRefresh;
    end
  else
    begin
      for i := 0 to High(FileNames) do
        if FileExists(FileNames[i]) then
          vftInDeface.AddFile(FileNames[i])
        else
          if DirectoryExists(FileNames[i]) then
            vftInDeface.AddDir(FileNames[i]);
      vftFileRefresh;
    end;
end;

procedure TfrmMain.lbxCodeFileListSelectionChange(Sender: TObject;
  User: boolean);
begin
  actInDefaceCodeFileDel.Enabled := lbxCodeFileList.SelCount > 0;
end;

procedure TfrmMain.btnPasswordVisibleClick(Sender: TObject);
begin
  if btnPasswordVisible.Down then
    begin
      ImageList2.GetBitmap(1, btnPasswordVisible.Glyph);
      edtPassword.PasswordChar := '*';
    end
  else
    begin
      ImageList2.GetBitmap(0, btnPasswordVisible.Glyph);
      edtPassword.PasswordChar := #0;
    end;
end;

procedure TfrmMain.pacMainChange(Sender: TObject);
begin
  case pacMain.ActivePageIndex of
    0: InitInDefacePage;
    1: InitOutDefacePage;
  end;
end;

procedure TfrmMain.vftInDefaceChange(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
begin
  vftFileRefresh;
end;

procedure TfrmMain.lbxCodeFileListRefresh;
begin
  actInDefaceCodeFileDel.Enabled := lbxCodeFileList.SelCount > 0;
end;

procedure TfrmMain.vftFileRefresh;
begin
  actInDefaceFileDel.Enabled := vftInDeface.SelectedCount > 0;
  actSaveFile.Enabled := Assigned(vftInDeface.GetFirst);
end;

procedure TfrmMain.OutDefaceRefreshPage;
begin
  pacMain.ActivePage := pacOutDeface;
  actOutDeface.Enabled :=
    (Length(edtOutDefaceFile.Text) > 0) and
    FileExists(edtOutDefaceFile.Text);
end;

procedure TfrmMain.ArchiveFileNamesRead(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to OutDefacer.PackFileList.Count - 1 do
    if IsDirectory(OutDefacer.PackFileList[i]) then
      vftOutDeface.AddDir(ArchiveFileName(OutDefacer.PackFileList[i]))
    else
      vftOutDeface.AddFile(ArchiveFileName(OutDefacer.PackFileList[i]));
end;

procedure TfrmMain.StartInDeface;
begin
  pacMain.ActivePage := pacInDeface;
  Enabled := False;

  InDefacer.Clear;
  InDefacer.PassWord := edtPassword.Text;
  InDefacer.FileName := SaveDialog1.FileName;
  InDefacer.CodeFileList.Assign(lbxCodeFileList.Items);
  InDefacer.ProgressStart;

  vftInDeface.GetFilesOrDirectories(InDefacer.PackFileList, False, True, True, True);
  InDefacer.InDeface;

  Enabled := True;
  edtOutDefaceFile.Text := InDefacer.FileName;
end;

procedure TfrmMain.StartOutDeface;
begin
  pacMain.ActivePage := pacOutDeface;
  Enabled := False;

  OutDefacer.Clear;
  OutDefacer.OutPutDir := SelectDirectoryDialog1.FileName;
  OutDefacer.PassWord  := edtPassword.Text;
  OutDefacer.FileName  := edtOutDefaceFile.Text;
  OutDefacer.CodeFileList.Assign(lbxCodeFileList.Items);

  OutDefacer.ProgressStart;
  OutDefacer.OutDeface;

  Enabled := True;
end;

procedure TfrmMain.InitInDefacePage;
begin
  pspInDeface.Position := pspOutDeface.Position;
  gbxPassWord.Parent := pspInDefaceLeft;
  gbxCodeFile.Parent := pspInDefaceLeft;
  lbxCodeFileListRefresh;
  vftFileRefresh;
end;

procedure TfrmMain.InitOutDefacePage;
begin
  pspOutDeface.Position := pspInDeface.Position;
  gbxPassWord.Parent := pspOutDefaceLeft;
  gbxCodeFile.Parent := pspOutDefaceLeft;
  lbxCodeFileListRefresh;
  OutDefaceRefreshPage;
end;

procedure TfrmMain.LoadProperties;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FIniFile);
  try
    Left   := Ini.ReadInteger('Main', 'Left',   Screen.Width div 8);
    Top    := Ini.ReadInteger('Main', 'Top',    Screen.Height div 8);
    Width  := Ini.ReadInteger('Main', 'Width',  Screen.Width * 3 div 4);
    Height := Ini.ReadInteger('Main', 'Height', Screen.Height * 3 div 4);
    if (Left + Width > Screen.Width) or (Top + Height > Screen.Height) then begin
      Left:=   Screen.Width div 8;
      Top:=    Screen.Height div 8;
      Width:=  Screen.Width * 3 div 4;
      Height:= Screen.Height * 3 div 4;
    end;

    pspInDeface.Position  := Ini.ReadInteger('Main', 'SplitterPos', Width div 3);
    pspOutDeface.Position := Ini.ReadInteger('Main', 'SplitterPos', Width div 3);
  except
    on e: Exception do
      ShowMessage(e.Message);
  end;
  Ini.Free;
end;

procedure TfrmMain.SaveProperties;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(FIniFile);
  try
    Ini.WriteInteger('Main', 'Left',        Left);
    Ini.WriteInteger('Main', 'Top',         Top);
    Ini.WriteInteger('Main', 'Width',       Width);
    Ini.WriteInteger('Main', 'Height',      Height);
    Ini.WriteInteger('Main', 'SplitterPos', pspInDeface.Position);
  except
    on e: Exception do
      ShowMessage(e.Message);
  end;
  Ini.Free;
end;

end.

