unit DefacerTools;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LazFileUtils;

function DirectoryHasEntries(Dir: String): Boolean;
procedure SaveRandomCodeDataFile(aFileName: String);

implementation

function DirectoryHasEntries(Dir: String): Boolean;
var
  PathInfo: TSearchRec;
begin
  Result := False;
  if FindFirstUTF8(Dir + DirectorySeparator + '*.*', faAnyfile, PathInfo) = 0 then
  try
    repeat
      if (PathInfo.Name = '.') or (PathInfo.Name = '..') or
        (PathInfo.Name = '') then Continue;
      Result := True;
    until Result or (FindNextUTF8(PathInfo) <> 0);
  finally
    FindCloseUTF8(PathInfo);
  end;
end;

procedure SaveRandomCodeDataFile(aFileName: String);
var
  FS: TFileStream;
  i: Integer;
begin
  try
    FS := TFileStream.Create(aFileName, fmCreate);
    for i := 0 to 1000000 + Random(1000000) do
      FS.WriteByte(Random(256));
  finally
    FreeAndNil(FS);
  end;
end;

end.

