{*******************************************************************************
  Copyright (C) Michael W. Vogel m-w-vogel@gmx.de

  The contents of this file are subject to the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 3.0 of the License,
  or (at your option) any later version.
  You may obtain a copy of the LGPL at http://www.gnu.org/copyleft/.

  Software distributed under the License is distributed on an "AS IS" basis,
  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
  specific language governing rights and limitations under the License.

  Created 02.09.2015
*******************************************************************************}

unit ProgressForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
  Dialogs, StdCtrls, ComCtrls, Buttons;

type

  { TfrmProgress }

  TfrmProgress = class(TForm)
    lblDetail: TLabel;
    lblProgress: TLabel;
    ProgressBar1: TProgressBar;
    btnBreak: TSpeedButton;
    procedure FormCloseQuery({%H-}Sender: TObject;
      var CanClose: boolean);
    procedure FormCreate({%H-}Sender: TObject);
    procedure FormShow({%H-}Sender: TObject);
  private
    FCanClose: Boolean;
  public
    procedure ShowState({%H-}Sender: TObject; const PerMille: Integer; const Progress, Detail: String; var aBreak: Boolean);
    procedure CloseForm;
  end;

implementation

{$R *.lfm}

{ TfrmProgress }

procedure TfrmProgress.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  ProgressBar1.DoubleBuffered := True;
end;

procedure TfrmProgress.FormCloseQuery(
  Sender: TObject; var CanClose: boolean);
begin
  CanClose := FCanClose;
end;

procedure TfrmProgress.FormShow(Sender: TObject);
begin
  FCanClose := False;
end;

procedure TfrmProgress.ShowState(
  Sender: TObject; const PerMille: Integer; const Progress,
  Detail: String; var aBreak: Boolean);
begin
  lblProgress.Caption   := Progress;
  lblDetail.Caption     := Detail;
  ProgressBar1.Position := Permille;
  Application.ProcessMessages;
  aBreak := btnBreak.Down;
end;

procedure TfrmProgress.CloseForm;
begin
  FCanClose := True;
  Close;
end;

end.

